require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_GENERIC_PGTABLE_H)) {
    eval 'sub _ASM_GENERIC_PGTABLE_H () {1;}' unless defined(&_ASM_GENERIC_PGTABLE_H);
    unless(defined(&__HAVE_ARCH_PTEP_ESTABLISH)) {
	unless(defined(&__HAVE_ARCH_SET_PTE_ATOMIC)) {
	    eval 'sub ptep_establish {
	        local($__vma, $__address, $__ptep, $__entry) = @_;
    		eval q( &do {  &set_pte($__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	    }' unless defined(&ptep_establish);
	} else {
	    eval 'sub ptep_establish {
	        local($__vma, $__address, $__ptep, $__entry) = @_;
    		eval q( &do {  &set_pte_atomic($__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	    }' unless defined(&ptep_establish);
	}
    }
    unless(defined(&__HAVE_ARCH_PTEP_SET_ACCESS_FLAGS)) {
	eval 'sub ptep_set_access_flags {
	    local($__vma, $__address, $__ptep, $__entry, $__dirty) = @_;
    	    eval q( &do {  &set_pte($__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	}' unless defined(&ptep_set_access_flags);
    }
    unless(defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG)) {
	eval 'sub ptep_test_and_clear_young {
	    local($ptep) = @_;
    	    eval q({  &pte_t  &pte = *$ptep;  &if (! &pte_young( &pte)) 0;  &set_pte($ptep,  &pte_mkold( &pte)); 1; });
	}' unless defined(&ptep_test_and_clear_young);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_YOUNG_FLUSH)) {
	eval 'sub ptep_clear_flush_young {
	    local($__vma, $__address, $__ptep) = @_;
    	    eval q(({ \'int\'  &__young =  &ptep_test_and_clear_young($__ptep);  &if ( &__young)  &flush_tlb_page($__vma, $__address);  &__young; }));
	}' unless defined(&ptep_clear_flush_young);
    }
    unless(defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY)) {
	eval 'sub ptep_test_and_clear_dirty {
	    local($ptep) = @_;
    	    eval q({  &pte_t  &pte = *$ptep;  &if (! &pte_dirty( &pte)) 0;  &set_pte($ptep,  &pte_mkclean( &pte)); 1; });
	}' unless defined(&ptep_test_and_clear_dirty);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_DIRTY_FLUSH)) {
	eval 'sub ptep_clear_flush_dirty {
	    local($__vma, $__address, $__ptep) = @_;
    	    eval q(({ \'int\'  &__dirty =  &ptep_test_and_clear_dirty($__ptep);  &if ( &__dirty)  &flush_tlb_page($__vma, $__address);  &__dirty; }));
	}' unless defined(&ptep_clear_flush_dirty);
    }
    unless(defined(&__HAVE_ARCH_PTEP_GET_AND_CLEAR)) {
	eval 'sub ptep_get_and_clear {
	    local($ptep) = @_;
    	    eval q({  &pte_t  &pte = *$ptep;  &pte_clear($ptep);  &pte; });
	}' unless defined(&ptep_get_and_clear);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_FLUSH)) {
	eval 'sub ptep_clear_flush {
	    local($__vma, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte =  &ptep_get_and_clear($__ptep);  &flush_tlb_page($__vma, $__address);  &__pte; }));
	}' unless defined(&ptep_clear_flush);
    }
    unless(defined(&__HAVE_ARCH_PTEP_SET_WRPROTECT)) {
	eval 'sub ptep_set_wrprotect {
	    local($ptep) = @_;
    	    eval q({  &pte_t  &old_pte = *$ptep;  &set_pte($ptep,  &pte_wrprotect( &old_pte)); });
	}' unless defined(&ptep_set_wrprotect);
    }
    unless(defined(&__HAVE_ARCH_PTEP_MKDIRTY)) {
	eval 'sub ptep_mkdirty {
	    local($ptep) = @_;
    	    eval q({  &pte_t  &old_pte = *$ptep;  &set_pte($ptep,  &pte_mkdirty( &old_pte)); });
	}' unless defined(&ptep_mkdirty);
    }
    unless(defined(&__HAVE_ARCH_PTE_SAME)) {
	eval 'sub pte_same {
	    local($A,$B) = @_;
    	    eval q(( &pte_val($A) ==  &pte_val($B)));
	}' unless defined(&pte_same);
    }
    unless(defined(&__HAVE_ARCH_PAGE_TEST_AND_CLEAR_DIRTY)) {
	eval 'sub page_test_and_clear_dirty {
	    local($page) = @_;
    	    eval q((0));
	}' unless defined(&page_test_and_clear_dirty);
    }
    unless(defined(&__HAVE_ARCH_PAGE_TEST_AND_CLEAR_YOUNG)) {
	eval 'sub page_test_and_clear_young {
	    local($page) = @_;
    	    eval q((0));
	}' unless defined(&page_test_and_clear_young);
    }
    unless(defined(&__HAVE_ARCH_PGD_OFFSET_GATE)) {
	eval 'sub pgd_offset_gate {
	    local($mm, $addr) = @_;
    	    eval q( &pgd_offset($mm, $addr));
	}' unless defined(&pgd_offset_gate);
    }
}
1;
