require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PGTABLE_3LEVEL_H)) {
    eval 'sub _I386_PGTABLE_3LEVEL_H () {1;}' unless defined(&_I386_PGTABLE_3LEVEL_H);
    eval 'sub pte_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %p(%08lx%08lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e), ($e). &pte_high, ($e). &pte_low));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %p(%016Lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub pgd_present {
        local($pgd) = @_;
	    eval q({ 1; } \'int\'  &pte_x( &pte_t  &pte) { !( &pte_val( &pte) &  &_PAGE_NX); });
    }' unless defined(&pgd_present);
    eval 'sub __HAVE_ARCH_SET_PTE_ATOMIC () {1;}' unless defined(&__HAVE_ARCH_SET_PTE_ATOMIC);
    eval 'sub set_pte_atomic {
        local($pteptr,$pteval) = @_;
	    eval q( &set_64bit(($pteptr), &pte_val($pteval)));
    }' unless defined(&set_pte_atomic);
    eval 'sub set_pmd {
        local($pmdptr,$pmdval) = @_;
	    eval q( &set_64bit(($pmdptr), &pmd_val($pmdval)));
    }' unless defined(&set_pmd);
    eval 'sub set_pgd {
        local($pgdptr,$pgdval) = @_;
	    eval q( &set_64bit(($pgdptr), &pgd_val($pgdval)));
    }' unless defined(&set_pgd);
    eval 'sub pgd_page {
        local($pgd) = @_;
	    eval q((  &__va( &pgd_val($pgd) &  &PAGE_MASK)));
    }' unless defined(&pgd_page);
    eval 'sub pmd_offset {
        local($dir, $address) = @_;
	    eval q((( &pmd_t *)  &pgd_page(*($dir)) +  &pmd_index($address)));
    }' unless defined(&pmd_offset);
    eval 'sub ptep_get_and_clear {
        local($ptep) = @_;
	    eval q({  &pte_t  &res;  ($res->{pte_low}) =  &xchg( ($ptep->{pte_low}), 0);  ($res->{pte_high}) =  ($ptep->{pte_high});  ($ptep->{pte_high}) = 0;  &res; });
    }' unless defined(&ptep_get_and_clear);
    eval 'sub pte_same {
        local($a,$b) = @_;
	    eval q({  ($a->{pte_low}) ==  ($b->{pte_low})  &&  ($a->{pte_high}) ==  ($b->{pte_high}); });
    }' unless defined(&pte_same);
    eval 'sub pte_page {
        local($x) = @_;
	    eval q( &pfn_to_page( &pte_pfn($x)));
    }' unless defined(&pte_page);
    eval 'sub pte_none {
        local($pte) = @_;
	    eval q({ ! ($pte->{pte_low})  && ! ($pte->{pte_high}); });
    }' unless defined(&pte_none);
    eval 'sub pte_pfn {
        local($pte) = @_;
	    eval q({ ( ($pte->{pte_low}) >>  &PAGE_SHIFT) | ( ($pte->{pte_high}) << (32-  &PAGE_SHIFT)); });
    }' unless defined(&pte_pfn);
    eval 'sub pfn_pte {
        local($page_nr,$pgprot) = @_;
	    eval q({  &pte_t  &pte;  ($pte->{pte_high}) = ($page_nr >> (32-  &PAGE_SHIFT)) | ( &pgprot_val($pgprot) >> 32);  ($pte->{pte_high}) &= ( &__supported_pte_mask >> 32);  ($pte->{pte_low}) = (($page_nr <<  &PAGE_SHIFT) |  &pgprot_val($pgprot)) &  &__supported_pte_mask;  &pte; });
    }' unless defined(&pfn_pte);
    eval 'sub pfn_pmd {
        local($page_nr,$pgprot) = @_;
	    eval q({  &__pmd((($page_nr <<  &PAGE_SHIFT) |  &pgprot_val($pgprot)) &  &__supported_pte_mask); });
    }' unless defined(&pfn_pmd);
    eval 'sub pte_to_pgoff {
        local($pte) = @_;
	    eval q((($pte). &pte_high));
    }' unless defined(&pte_to_pgoff);
    eval 'sub pgoff_to_pte {
        local($off) = @_;
	    eval q((( &pte_t) {  &_PAGE_FILE, ($off) }));
    }' unless defined(&pgoff_to_pte);
    eval 'sub PTE_FILE_MAX_BITS () {32;}' unless defined(&PTE_FILE_MAX_BITS);
    eval 'sub __swp_type {
        local($x) = @_;
	    eval q(((($x). &val) & 0x1f));
    }' unless defined(&__swp_type);
    eval 'sub __swp_offset {
        local($x) = @_;
	    eval q((($x). &val >> 5));
    }' unless defined(&__swp_offset);
    eval 'sub __swp_entry {
        local($type, $offset) = @_;
	    eval q((( &swp_entry_t){($type) | ($offset) << 5}));
    }' unless defined(&__swp_entry);
    eval 'sub __pte_to_swp_entry {
        local($pte) = @_;
	    eval q((( &swp_entry_t){ ($pte). &pte_high }));
    }' unless defined(&__pte_to_swp_entry);
    eval 'sub __swp_entry_to_pte {
        local($x) = @_;
	    eval q((( &pte_t){ 0, ($x). &val }));
    }' unless defined(&__swp_entry_to_pte);
}
1;
