require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IO_H)) {
    eval 'sub _ASM_IO_H () {1;}' unless defined(&_ASM_IO_H);
    require 'linux/config.ph';
    if(defined(&SLOW_IO_BY_JUMPING)) {
	eval 'sub __SLOW_DOWN_IO () {"\\njmp 1f\\n1:\\tjmp 1f\\n1:";}' unless defined(&__SLOW_DOWN_IO);
    } else {
	eval 'sub __SLOW_DOWN_IO () {"\\noutb %%al,$0x80";}' unless defined(&__SLOW_DOWN_IO);
    }
    if(defined(&REALLY_SLOW_IO)) {
	eval 'sub __FULL_SLOW_DOWN_IO () { &__SLOW_DOWN_IO  &__SLOW_DOWN_IO  &__SLOW_DOWN_IO  &__SLOW_DOWN_IO;}' unless defined(&__FULL_SLOW_DOWN_IO);
    } else {
	eval 'sub __FULL_SLOW_DOWN_IO () { &__SLOW_DOWN_IO;}' unless defined(&__FULL_SLOW_DOWN_IO);
    }
    eval 'sub __OUT1 {
        local($s,$x) = @_;
	    eval q( &extern  &inline  &void  &out$s(\'unsigned x value\', \'unsigned short port\') {);
    }' unless defined(&__OUT1);
    eval 'sub __OUT2 {
        local($s,$s1,$s2) = @_;
	    eval q( &__asm__  &__volatile__ (\\"out\\" $s \\" %\\" $s1 \\"0,%\\" $s2 \\"1\\");
    }' unless defined(&__OUT2);
    eval 'sub __OUT {
        local($s,$s1,$x) = @_;
	    eval q( &__OUT1($s,$x)  &__OUT2($s,$s1,\\"w\\") : : \\"a\\" ( &value), \\"Nd\\" ( &port)); }  &__OUT1($s &_p,$x)  &__OUT2($s,$s1,\\"w\\")  &__FULL_SLOW_DOWN_IO : : \\"a\\" ( &value), \\"Nd\\" ( &port));});
    }' unless defined(&__OUT);
    eval 'sub __IN1 {
        local($s) = @_;
	    eval q( &extern  &inline  &RETURN_TYPE  &in$s {  &RETURN_TYPE  &_v;);
    }' unless defined(&__IN1);
    eval 'sub __IN2 {
        local($s,$s1,$s2) = @_;
	    eval q( &__asm__  &__volatile__ (\\"in\\" $s \\" %\\" $s2 \\"1,%\\" $s1 \\"0\\");
    }' unless defined(&__IN2);
    eval 'sub __IN () {( &s, &s1, &i...)  &__IN1( &s)  &__IN2( &s, &s1,"w") : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; }  &__IN1( &s &_p)  &__IN2( &s, &s1,"w")  &__FULL_SLOW_DOWN_IO : "=a" ( &_v) : "Nd" ( &port) , &i );  &return  &_v; };}' unless defined(&__IN);
    eval 'sub __INS {
        local($s) = @_;
	    eval q( &extern  &inline  &void  &ins$s(\'unsigned short port\',  &void *  &addr, \'unsigned long count\') {  &__asm__  &__volatile__ (\\"rep ; ins\\" $s : \\"=D\\" ( &addr), \\"=c\\" ( &count) : \\"d\\" ( &port),\\"0\\" ( &addr),\\"1\\" ( &count)); });
    }' unless defined(&__INS);
    eval 'sub __OUTS {
        local($s) = @_;
	    eval q( &extern  &inline  &void  &outs$s(\'unsigned short port\',  &const  &void *  &addr, \'unsigned long count\') {  &__asm__  &__volatile__ (\\"rep ; outs\\" $s : \\"=S\\" ( &addr), \\"=c\\" ( &count) : \\"d\\" ( &port),\\"0\\" ( &addr),\\"1\\" ( &count)); });
    }' unless defined(&__OUTS);
    eval 'sub RETURN_TYPE () {\'unsigned char\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
    eval 'sub RETURN_TYPE () {\'unsigned short\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
    eval 'sub RETURN_TYPE () {\'unsigned int\';}' unless defined(&RETURN_TYPE);
    undef(&RETURN_TYPE) if defined(&RETURN_TYPE);
    eval 'sub IO_SPACE_LIMIT () {0xffff;}' unless defined(&IO_SPACE_LIMIT);
    if(defined( &__KERNEL__)  && (defined(&__x86_64__) ? &__x86_64__ : 0)) {
	require 'linux/vmalloc.ph';
	unless(defined(&__i386__)) {
	    eval 'sub phys_to_virt {
	        local($address) = @_;
    		eval q({  &__va($address); });
	    }' unless defined(&phys_to_virt);
	}
	if(defined(&CONFIG_DISCONTIGMEM)) {
	    require 'asm/mmzone.ph';
	    eval 'sub page_to_phys {
	        local($page) = @_;
    		eval q((( &dma_addr_t) &page_to_pfn($page) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	} else {
	    eval 'sub page_to_phys {
	        local($page) = @_;
    		eval q((($page -  &mem_map) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	}
	require 'asm-generic/iomap.ph';
	eval 'sub ioremap {
	    local($offset,$size) = @_;
    	    eval q({  &__ioremap($offset, $size, 0); });
	}' unless defined(&ioremap);
	eval 'sub isa_virt_to_bus () { &virt_to_phys;}' unless defined(&isa_virt_to_bus);
	eval 'sub isa_page_to_bus () { &page_to_phys;}' unless defined(&isa_page_to_bus);
	eval 'sub isa_bus_to_virt () { &phys_to_virt;}' unless defined(&isa_bus_to_virt);
	eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
	eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
	eval 'sub __readw {
	    local($addr) = @_;
    	    eval q({ *( &__force  &volatile  &__u16 *)$addr; });
	}' unless defined(&__readw);
	eval 'sub __readl {
	    local($addr) = @_;
    	    eval q({ *( &__force  &volatile  &__u32 *)$addr; });
	}' unless defined(&__readl);
	eval 'sub __readq {
	    local($addr) = @_;
    	    eval q({ *( &__force  &volatile  &__u64 *)$addr; });
	}' unless defined(&__readq);
	eval 'sub readb {
	    local($x) = @_;
    	    eval q( &__readb($x));
	}' unless defined(&readb);
	eval 'sub readw {
	    local($x) = @_;
    	    eval q( &__readw($x));
	}' unless defined(&readw);
	eval 'sub readl {
	    local($x) = @_;
    	    eval q( &__readl($x));
	}' unless defined(&readl);
	eval 'sub readq {
	    local($x) = @_;
    	    eval q( &__readq($x));
	}' unless defined(&readq);
	eval 'sub readb_relaxed {
	    local($a) = @_;
    	    eval q( &readb($a));
	}' unless defined(&readb_relaxed);
	eval 'sub readw_relaxed {
	    local($a) = @_;
    	    eval q( &readw($a));
	}' unless defined(&readw_relaxed);
	eval 'sub readl_relaxed {
	    local($a) = @_;
    	    eval q( &readl($a));
	}' unless defined(&readl_relaxed);
	eval 'sub readq_relaxed {
	    local($a) = @_;
    	    eval q( &readq($a));
	}' unless defined(&readq_relaxed);
	eval 'sub __raw_readb () { &readb;}' unless defined(&__raw_readb);
	eval 'sub __raw_readw () { &readw;}' unless defined(&__raw_readw);
	eval 'sub __raw_readl () { &readl;}' unless defined(&__raw_readl);
	eval 'sub __raw_readq () { &readq;}' unless defined(&__raw_readq);
	eval 'sub mmiowb () {
	    eval q();
	}' unless defined(&mmiowb);
	if(defined(&CONFIG_UNORDERED_IO)) {
	    eval 'sub __writel {
	        local($val,$addr) = @_;
    		eval q({  &volatile  &__u32  &__iomem * &target = $addr;  &asm  &volatile(\\"movnti %1,%0\\" : \\"=m\\" (* &target) : \\"r\\" ($val) : \\"memory\\"); });
	    }' unless defined(&__writel);
	    eval 'sub __writeq {
	        local($val,$addr) = @_;
    		eval q({  &volatile  &__u64  &__iomem * &target = $addr;  &asm  &volatile(\\"movnti %1,%0\\" : \\"=m\\" (* &target) : \\"r\\" ($val) : \\"memory\\"); });
	    }' unless defined(&__writeq);
	} else {
	    eval 'sub __writel {
	        local($b,$addr) = @_;
    		eval q({ *( &__force  &volatile  &__u32 *)$addr = $b; });
	    }' unless defined(&__writel);
	    eval 'sub __writeq {
	        local($b,$addr) = @_;
    		eval q({ *( &__force  &volatile  &__u64 *)$addr = $b; });
	    }' unless defined(&__writeq);
	}
	eval 'sub __writeb {
	    local($b,$addr) = @_;
    	    eval q({ *( &__force  &volatile  &__u8 *)$addr = $b; });
	}' unless defined(&__writeb);
	eval 'sub __writew {
	    local($b,$addr) = @_;
    	    eval q({ *( &__force  &volatile  &__u16 *)$addr = $b; });
	}' unless defined(&__writew);
	eval 'sub writeq {
	    local($val,$addr) = @_;
    	    eval q( &__writeq(($val),($addr)));
	}' unless defined(&writeq);
	eval 'sub writel {
	    local($val,$addr) = @_;
    	    eval q( &__writel(($val),($addr)));
	}' unless defined(&writel);
	eval 'sub writew {
	    local($val,$addr) = @_;
    	    eval q( &__writew(($val),($addr)));
	}' unless defined(&writew);
	eval 'sub writeb {
	    local($val,$addr) = @_;
    	    eval q( &__writeb(($val),($addr)));
	}' unless defined(&writeb);
	eval 'sub __raw_writeb () { &writeb;}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew () { &writew;}' unless defined(&__raw_writew);
	eval 'sub __raw_writel () { &writel;}' unless defined(&__raw_writel);
	eval 'sub __raw_writeq () { &writeq;}' unless defined(&__raw_writeq);
	eval 'sub void {
	    eval q(* &memcpy_fromio( &void * &to,  &volatile  &void  &__iomem * &from, my $len) {  &__memcpy_fromio( &to, &from, $len); });
	}' unless defined(&void);
	eval 'sub void {
	    eval q(* &memcpy_toio( &volatile  &void  &__iomem * &to,  &const  &void * &from, my $len) {  &__memcpy_toio( &to, &from, $len); });
	}' unless defined(&void);
	eval 'sub void {
	    eval q(* &memset_io( &volatile  &void  &__iomem * &a, \'int\'  &b, \'size_t\'  &c) {  &memset(( &__force  &void *) &a, &b, &c); });
	}' unless defined(&void);
	eval 'sub __ISA_IO_base () {((\'char\'  &__iomem *)( &PAGE_OFFSET));}' unless defined(&__ISA_IO_base);
	eval 'sub isa_readb {
	    local($a) = @_;
    	    eval q( &readb( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readb);
	eval 'sub isa_readw {
	    local($a) = @_;
    	    eval q( &readw( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readw);
	eval 'sub isa_readl {
	    local($a) = @_;
    	    eval q( &readl( &__ISA_IO_base + ($a)));
	}' unless defined(&isa_readl);
	eval 'sub isa_writeb {
	    local($b,$a) = @_;
    	    eval q( &writeb($b, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writeb);
	eval 'sub isa_writew {
	    local($w,$a) = @_;
    	    eval q( &writew($w, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writew);
	eval 'sub isa_writel {
	    local($l,$a) = @_;
    	    eval q( &writel($l, &__ISA_IO_base + ($a)));
	}' unless defined(&isa_writel);
	eval 'sub isa_memset_io {
	    local($a,$b,$c) = @_;
    	    eval q( &memset_io( &__ISA_IO_base + ($a),($b),($c)));
	}' unless defined(&isa_memset_io);
	eval 'sub isa_memcpy_fromio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy_fromio(($a), &__ISA_IO_base + ($b),($c)));
	}' unless defined(&isa_memcpy_fromio);
	eval 'sub isa_memcpy_toio {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy_toio( &__ISA_IO_base + ($a),($b),($c)));
	}' unless defined(&isa_memcpy_toio);
	eval 'sub eth_io_copy_and_sum {
	    local($a,$b,$c,$d) = @_;
    	    eval q( &eth_copy_and_sum(($a),( &void *)($b),($c),($d)));
	}' unless defined(&eth_io_copy_and_sum);
	eval 'sub isa_eth_io_copy_and_sum {
	    local($a,$b,$c,$d) = @_;
    	    eval q( &eth_copy_and_sum(($a),( &void *)( &__ISA_IO_base + ($b)),($c),($d)));
	}' unless defined(&isa_eth_io_copy_and_sum);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
	eval 'sub flush_write_buffers () {
	    eval q();
	}' unless defined(&flush_write_buffers);
	eval 'sub BIO_VMERGE_BOUNDARY () { &iommu_bio_merge;}' unless defined(&BIO_VMERGE_BOUNDARY);
    }
}
1;
