require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&LINUX_HARDIRQ_H)) {
    eval 'sub LINUX_HARDIRQ_H () {1;}' unless defined(&LINUX_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/smp_lock.ph';
    require 'asm/hardirq.ph';
    eval 'sub PREEMPT_BITS () {8;}' unless defined(&PREEMPT_BITS);
    eval 'sub SOFTIRQ_BITS () {8;}' unless defined(&SOFTIRQ_BITS);
    unless(defined(&HARDIRQ_BITS)) {
	eval 'sub HARDIRQ_BITS () {12;}' unless defined(&HARDIRQ_BITS);
	if((1<< (defined(&HARDIRQ_BITS) ? &HARDIRQ_BITS : 0)) < (defined(&NR_IRQS) ? &NR_IRQS : 0)) {
	    die("HARDIRQ_BITS\ is\ too\ low\!");
	}
    }
    eval 'sub PREEMPT_SHIFT () {0;}' unless defined(&PREEMPT_SHIFT);
    eval 'sub SOFTIRQ_SHIFT () {( &PREEMPT_SHIFT +  &PREEMPT_BITS);}' unless defined(&SOFTIRQ_SHIFT);
    eval 'sub HARDIRQ_SHIFT () {( &SOFTIRQ_SHIFT +  &SOFTIRQ_BITS);}' unless defined(&HARDIRQ_SHIFT);
    eval 'sub __IRQ_MASK {
        local($x) = @_;
	    eval q(((1 << ($x))-1));
    }' unless defined(&__IRQ_MASK);
    eval 'sub PREEMPT_MASK () {( &__IRQ_MASK( &PREEMPT_BITS) <<  &PREEMPT_SHIFT);}' unless defined(&PREEMPT_MASK);
    eval 'sub HARDIRQ_MASK () {( &__IRQ_MASK( &HARDIRQ_BITS) <<  &HARDIRQ_SHIFT);}' unless defined(&HARDIRQ_MASK);
    eval 'sub SOFTIRQ_MASK () {( &__IRQ_MASK( &SOFTIRQ_BITS) <<  &SOFTIRQ_SHIFT);}' unless defined(&SOFTIRQ_MASK);
    eval 'sub PREEMPT_OFFSET () {(1 <<  &PREEMPT_SHIFT);}' unless defined(&PREEMPT_OFFSET);
    eval 'sub SOFTIRQ_OFFSET () {(1 <<  &SOFTIRQ_SHIFT);}' unless defined(&SOFTIRQ_OFFSET);
    eval 'sub HARDIRQ_OFFSET () {(1 <<  &HARDIRQ_SHIFT);}' unless defined(&HARDIRQ_OFFSET);
    eval 'sub hardirq_count () {
        eval q(( &preempt_count() &  &HARDIRQ_MASK));
    }' unless defined(&hardirq_count);
    eval 'sub softirq_count () {
        eval q(( &preempt_count() &  &SOFTIRQ_MASK));
    }' unless defined(&softirq_count);
    eval 'sub irq_count () {
        eval q(( &preempt_count() & ( &HARDIRQ_MASK |  &SOFTIRQ_MASK)));
    }' unless defined(&irq_count);
    eval 'sub in_irq () {
        eval q(( &hardirq_count()));
    }' unless defined(&in_irq);
    eval 'sub in_softirq () {
        eval q(( &softirq_count()));
    }' unless defined(&in_softirq);
    eval 'sub in_interrupt () {
        eval q(( &irq_count()));
    }' unless defined(&in_interrupt);
    if(defined(&CONFIG_PREEMPT)) {
	eval 'sub in_atomic () {
	    eval q((( &preempt_count() & ~ &PREEMPT_ACTIVE) !=  &kernel_locked()));
	}' unless defined(&in_atomic);
	eval 'sub preemptible () {
	    eval q(( &preempt_count() == 0 && ! &irqs_disabled()));
	}' unless defined(&preemptible);
	eval 'sub IRQ_EXIT_OFFSET () {( &HARDIRQ_OFFSET-1);}' unless defined(&IRQ_EXIT_OFFSET);
    } else {
	eval 'sub in_atomic () {
	    eval q(( &preempt_count() != 0));
	}' unless defined(&in_atomic);
	eval 'sub preemptible () {
	    eval q(0);
	}' unless defined(&preemptible);
	eval 'sub IRQ_EXIT_OFFSET () { &HARDIRQ_OFFSET;}' unless defined(&IRQ_EXIT_OFFSET);
    }
    if(defined(&CONFIG_SMP)) {
    } else {
	eval 'sub synchronize_irq {
	    local($irq) = @_;
    	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    }
    if(defined(&CONFIG_GENERIC_HARDIRQS)) {
	eval 'sub nmi_enter () {
	    eval q(( &preempt_count() +=  &HARDIRQ_OFFSET));
	}' unless defined(&nmi_enter);
	eval 'sub nmi_exit () {
	    eval q(( &preempt_count() -=  &HARDIRQ_OFFSET));
	}' unless defined(&nmi_exit);
	eval 'sub irq_enter () {
	    eval q(( &preempt_count() +=  &HARDIRQ_OFFSET));
	}' unless defined(&irq_enter);
    }
}
1;
